<?php

namespace FiloBlu\Rma\Plugin\Model;

/**
 * Class Rma
 * @package FiloBlu\Rma\Plugin\Model
 */
class Rma
{
    /**
     * @var \FiloBlu\Rma\Model\Rma\Status\HistoryFactory
     */
    protected $historyFactory;

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $logger;

    /**
     * Rma constructor.
     * @param \FiloBlu\Rma\Model\Rma\Status\HistoryFactory $historyFactory
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(\FiloBlu\Rma\Model\Rma\Status\HistoryFactory $historyFactory,\Psr\Log\LoggerInterface $logger)
    {
        $this->historyFactory = $historyFactory;
        $this->logger = $logger;
    }

    /**
     * @param \Magento\Rma\Model\Rma $subject
     * @param \Magento\Rma\Model\Rma|false $result
     * @return bool
     */
    public function afterSaveRma(\Magento\Rma\Model\Rma $subject, $result)
    {
        if ($result === false) {
            return false;
        }

        try {

            $originalData = $result->getOrigData();
            $status = $result->getStatus();

          /*  if ($status == $originalData['status']) {
                return $result;
            }*/

            switch ($status) {
                case  \Magento\Rma\Model\Rma\Source\Status::STATE_RECEIVED:

                    /** @var $result Magento\Rma\Model\Rma */
                    /** @var $statusHistory \FiloBlu\Rma\Model\Rma\Status\History */
                    $statusHistory = $this->historyFactory->create();
                    $statusHistory->setRmaEntityId($result->getEntityId());
                    $statusHistory->sendReceivedEmail();
                    break;
            }

        } catch (\Exception $e) {
            $this->logger->critical($e);
        }

        return $result;
    }
}

